SUBSCHEMA Geometry  AUTHOR 'offline group'

/*

  All sizes are full size (lengths and diameters)

  Prefixes: n= number (1)
            s= size (cm)
            p= position (cm)
            a= angle (degrees)
*/

DEFINE ESET
 dVersion=( iVersion = INTE [1,*] : 'Version number',
            iBegDate = INTE [930101,990000] : 'creation date (e.g. 930401)',
            iBegTime = INTE [0,235959]      : 'creation time (e.g. 120000)',
            iEndDate = INTE [930101,990000] : 'end date of validity',
            iEndTime = INTE [0,235959]      : 'end time of validity',
            cType    = CH32       : 'Selection type')
            : 'Key for geometry data base file version';
END ESET

DEFINE ESET
 dVCDet=(
  cName   = CHA4
       'V1U'|'V2U'|'V1L'|'V2L'
                              : 'name of detector',
  nPlanes = INTE [1,6]        : 'number of planes',
  sWidth  = REAL [1.0,300.]   : 'x-size of the det. aperture',
  sHeight = REAL [1.0,200.]   : 'y-size of the det. aperture',
  pXCent  = REAL [-10.0,10.]  : 'x-position of the aperture center',
  pYCent  = REAL [-100.0,100.]: 'y-position of the aperture center',
  pZCent  = REAL [-300.0,500.]: 'z-position of the aperture center',
  sFoilEnter= REAL [0.000,50.]  : 'total thickness of entrance foil material',
  sFoilExit= REAL [0.000,50.]  : 'total thickness of exit foil material',
  sFrameDepth = REAL [0.1,100.] : 'z-size of the det. frame',
  sFrameUp    = REAL [0.1,50.]  : 'Upper width of the det. frame',
  sFrameLo    = REAL [0.1,50.]  : 'Lower width of the det. frame',
  sFrameRi    = REAL [0.1,50.]  : 'Right width of the det. frame',
  sFrameLe    = REAL [0.1,50.]  : 'Left width of the det. frame',
  sClearX = REAL [0.000,50.]	: 'X clearance in frame around beam axis for beam pipe',
  sClearY = REAL [0.000,50.]	: 'Y clearance in frame around beam axis for beam pipe')

 : 'VC geometry description';
END ESET

DEFINE ESET
 dVCPl=(
  cType   = CHA4 'u'|'v'|'x'|'y' : 'type of plane',
  iPlane  = INTE [1,6]       : 'ID of this plane in detector',
  iDivFlag = INTE            : 'Nopn-zero to use subdivided volume',
  sWidth  = REAL [0.1,30.]   : 'y-size of the plane',
  sDepth  = REAL [0.1,30.]   : 'z-size of the plane',
  pXCent= REAL [-50.0,50.] : 'x-position of this plane rel.to detector cent.',
  pYCent= REAL [-50.0,50.] : 'y-position of this plane rel.to detector cent.',
  pZCent= REAL [-50.0,50.] : 'z-position of this plane rel.to detector cent.',
  nWires  = INTE [10,2000]   : 'number of sense wires in plane',
  aWire   = REAL [-10.0,180.] : 'sense wire angle',
  aResolu   = REAL [-1.000,.1]       : 'spatial resolution (-1 for no resol.)',
  pWire1= REAL [-200.00,-0.1] : 'position of first wire along plane coord.',
  sWire      = REAL [0.005,20.] : 'sense wire spacing',
  sWireDiam  = REAL [0.005,0.5] : 'sense wire diameter',
  sWireP     = REAL [0.005,20.] : 'potent.wire spacing',
  sWirePDiam = REAL [0.005,0.5] : 'potential wire diameter',
  sFoil1  = REAL [0.000,50.]       : 'total thickness of foil material 1',
  sFoil2  = REAL [0.000,50.]       : 'total thickness of foil material 2')

 : 'VC plane geometry description';
END ESET

DEFINE ESET
 dWireDet=(
  cName   = CHA4
       'F1U'|'F2U'|'M1U'|'M2U'|'M3U'|'B1U'|'B2U'|'B3U'|'B4U'|
       'F1L'|'F2L'|'M1L'|'M2L'|'M3L'|'B1L'|'B2L'|'B3L'|'B4L'
                              : 'name of detector',
  nPlanes = INTE [1,6]        : 'number of planes',
  sWidth  = REAL [1.0,300.]   : 'x-size of the det. aperture',
  sHeight = REAL [1.0,200.]   : 'y-size of the det. aperture',
  pXCent  = REAL [-10.0,10.]  : 'x-position of the aperture center',
  pYCent  = REAL [-100.0,100.]: 'y-position of the aperture center',
  pZCent  = REAL [-300.0,500.]: 'z-position of the aperture center',
  sFoilEnter= REAL [0.000,50.]  : 'total thickness of entrance foil material',
  sFoilExit= REAL [0.000,50.]  : 'total thickness of exit foil material',
  sFrameFr    = REAL [0.1,50.]  : 'Amount frame extends beyond first plane',
  sFrameBa    = REAL [0.1,50.]  : 'Amount frame extends behind last plane',
  sFrameUp    = REAL [0.1,50.]  : 'Upper width of the det. frame',
  sFrameLo    = REAL [0.1,50.]  : 'Lower width of the det. frame',
  sFrameRi    = REAL [0.1,50.]  : 'Right width of the det. frame',
  sFrameLe    = REAL [0.1,50.]  : 'Left width of the det. frame',
  sDepth  = REAL [0.1,30.]   : 'z-size of each plane',
  sSpacing  = REAL [0.1,30.]   : 'z-distance between each sensitive wire plane',
  sWireDiam  = REAL [0.005,0.5] : 'sense wire diameter',
  sWirePDiam = REAL [0.005,0.5] : 'potential wire diameter',
  sFoil1  = REAL [0.000,50.]	: 'total thickness of foil material 1',
  sFoil2  = REAL [0.000,50.]	: 'total thickness of foil material 2',
  sClearX = REAL [0.000,50.]	: 'X clearance in frame around beam axis for beam pipe',
  sClearY = REAL [0.000,50.]	: 'Y clearance in frame around beam axis for beam pipe')

 : 'wire chamber geometry description';
END ESET

DEFINE ESET
 dWirePl=(
  cType   = CHA4 'u'|'v'|'x'|'y' : 'type of plane',
  iPlane  = INTE [1,6]       : 'ID of this plane in detector',
  iDivFlag = INTE            : 'Nopn-zero to use subdivided volume',
  pXCent= REAL [-50.0,50.] : 'x-position of this plane rel.to detector cent.',
  pYCent= REAL [-50.0,50.] : 'y-position of this plane rel.to detector cent.',
  nWires  = INTE [10,2000]   : 'number of sense wires in plane',
  aWire   = REAL [-10.0,180.] : 'sense wire angle',
  aResolu   = REAL [-1.000,.1]       : 'spatial resolution (-1 for no resol.)',
  pWire1= REAL [-200.00,-0.1] : 'position of first wire along plane coord.',
  sWire      = REAL [0.005,20.] : 'sense wire spacing',
  sWireP     = REAL [0.005,20.] : 'potent.wire spacing')

 : 'wire chamber plane geometry description';
END ESET

DEFINE ESET
 dDummyDet=(
  cName = CHA4	:  'Detector Names apparently must be unique',
  iType = INTE	:  'To allow special code for different types of Dummies',
  rPar(10)= REAL: 'Up to 10 detector specific parameters'
  )
 : 'Link to Pieces contains relevant info';
END ESET

DEFINE ESET
 dTRDDet=(
  cName   = CHA4 'T_U'|'T_L'  : 'name of detector',
  nPlanes = INTE [1,6]        : 'number of planes',
  sWidth  = REAL [1.0,300.]   : 'x-size of the det. aperture',
  sHeight = REAL [1.0,200.]   : 'y-size of the det. aperture',
  pXCent  = REAL [-10.0,10.]  : 'x-position of the aperture center',
  pYCent  = REAL [-100.0,100.]: 'y-position of the aperture center',
  pZCent  = REAL [-300.0,500.]: 'z-position of the aperture center',
  sFoilEnter= REAL [0.000,50.]    : 'total thickness of entrance foil material',
  sFoilExit= REAL [0.000,50.]    : 'total thickness of exit foil material',
  sFrameUp    = REAL [0.1,50.]  : 'Upper width of the det. frame',
  sFrameLo    = REAL [0.1,50.]  : 'Lower width of the det. frame',
  sFrameRi    = REAL [0.1,50.]  : 'Right width of the det. frame',
  sFrameLe    = REAL [0.1,50.]  : 'Left width of the det. frame',
  sShield     = REAL [0.,50.]   : 'Thickness of shield in front of TRD',
  sDepth  = REAL [1.0,30.]   : 'z-size of the Detector region of each plane',
  sRadDepth  = REAL [1.0,30.] : 'z-size of the Radiator region of each plane',
  sFlushDepth  = REAL [0.00,50.] : 'z-size of each Flush Gap',
  sWireDiam  = REAL [0.005,0.5] : 'sense wire diameter',
  sFoil1  = REAL [0.000,50.]       : 'total thickness of foil material 1',
  sFoil2  = REAL [0.000,50.]       : 'total thickness of foil material 2')

 : 'TRD detector geometry description';
END ESET


DEFINE ESET
 dTRDPl=(
  iPlane  = INTE [1,6]       : 'ID of this plane in detector',
  iDivFlag = INTE            : 'Nopn-zero to use subdivided volume',
  nWires  = INTE [10,2000]   : 'number of sense wires in plane',
  aWire   = REAL [80.00,100.] : 'sense wire angle',
  aResolu   = REAL	: 'spatial resolution (-1 for no resol.)',
  pWire1= REAL [-200.0,-0.1] : 'position of first wire along plane coord.',
  sWire      = REAL [0.005,20.] : 'sense wire spacing')

 : 'TRD chamber plane geometry description';
END ESET


DEFINE ESET
 dShowerDet=(
  cName   = CHA4
      'BRU'|'BLU'|'H1U'|'PRU'|'CAU'|'LUL'|
      'BRL'|'BLL'|'H1L'|'PRL'|'CAL'|'LUR'
                              : 'name of detector',
  nRow    = INTE [1,15]       : 'number of rows (horiz.strip)',
  nCol    = INTE [1,50]       : 'number of columns (vert.strip)',
  sWidth  = REAL [1.0,400.]   : 'x-size of the det. aperture',
  sHeight = REAL [1.0,250.]   : 'y-size of the det. aperture',
  sDepth  = REAL [0.1,100.]   : 'z-size of the det. aperture',
  pXCent  = REAL [-200.,200.]  : 'x-position of the aperture center',
  pYCent  = REAL [-100.,100.]: 'y-position of the aperture center',
  pZCent  = REAL [-300.,800.]: 'z-position of the aperture center',
  aResolu   = REAL [-1.000,.1]       : 'spatial resolution (-1 for no resol.)',
  sRad        = REAL [0.00,50.] : 'thickness of radiator mat. before det.',
  sRadGap     = REAL [0.00,100.]: 'distance from back of radiator to front of aperture',
  sPM         = REAL [0.00,50.] : 'thickness of PM material behind det.',
  sFrameUp    = REAL [0.1,50.]  : 'Upper width of the det. frame',
  sFrameLo    = REAL [0.1,50.]  : 'Lower width of the det. frame',
  sFrameRi    = REAL [0.1,50.]  : 'Right width of the det. frame',
  sFrameLe    = REAL [0.1,50.]  : 'Left width of the det. frame',
  sClampWidth = REAL [0.1,100.] : 'x-size of clamps',
  sClampHeight= REAL [0.1,100.] : 'y-size of clamps',
  sClampDepth = REAL [0.1,100.] : 'z-size of clamps',
  sClampXCent = REAL [0.1,100.] : 'x-position of clamp center rel to ap center',
  sClampYCent = REAL [0.1,100.] : 'y-position of clamp center rel to ap center')

 : 'shower detector and cerencov geometry description';
END ESET


DEFINE ESET
 dBox=(
  cName       = CHA4            : 'Name of Volume',
  sWidth  = REAL [0.0,2000.]    : 'x-size of box',
  sHeight = REAL [0.0,2000.]    : 'y-size of box',
  sDepth  = REAL [0.0,2000.]    : 'z-size of box',
  sXYThickness  = REAL [0.0,2000.]: 'optional shell thickness of box')

 : 'rectangular volume description';
END ESET

DEFINE ESET
 dTube=(
  cName       = CHA4            : 'Name of Volume',
  sDiaOut = REAL [0.0,100.]     : 'Outer diameter of pipe',
  sDiaIn  = REAL [0.0,100.]     : 'Inner diameter of pipe',
  sDepth = REAL [0.0,2000.]     : 'Length of pipe')

 : 'tubular volume';
END ESET

DEFINE ESET
 dEllTube=(
  cName       = CHA4            : 'Name of Volume',
  sDiaXOut = REAL [0.0,100.]    : 'Outer X-diameter of pipe',
  sDiaYOut = REAL [0.0,100.]    : 'Outer Y-diameter of pipe',
  sDiaXIn  = REAL [0.0,100.]    : 'Inner Y-diameter of pipe',
  sDiaYIn  = REAL [0.0,100.]    : 'Inner Y-diameter of pipe',
  sDepth = REAL [0.0,2000.]     : 'Length of pipe')

 : 'Elliptical tubular volume';
END ESET

DEFINE ESET
 dSphere=(
  cName       = CHA4            : 'Name of Volume',
  sDiaOut = REAL [0.0,100.]     : 'Outer diameter of Sphere',
  sDiaIn  = REAL [0.0,100.]     : 'Inner diameter of Sphere',
  aTheta1 = REAL [0.0,180.]     : 'Starting Theta',
  aTheta2 = REAL [0.0,180.]     : 'Ending Theta',
  aPhi1 =   REAL [0.0,360.]     : 'Starting Phi',
  aPhi2 =   REAL [0.0,360.]     : 'Ending Phi')

 : 'Spherical Segment';
END ESET

DEFINE ESET
 dCone=(
  cName       = CHA4            : 'Name of Volume',
  sDiaOut1 = REAL [0.0,100.]     : 'Outer diameter of pipe entrance',
  sDiaIn1  = REAL [0.0,100.]     : 'Inner diameter of pipe entrance',
  sDiaOut2 = REAL [0.0,100.]     : 'Outer diameter of pipe exit',
  sDiaIn2  = REAL [0.0,100.]     : 'Inner diameter of pipe exit',
  sDepth  = REAL [0.0,2000.]    : 'Length of pipe')

 : 'conical tube volume';
END ESET

DEFINE ESET
 dWedge=(
  cName       = CHA4            : 'Name of Volume',
  sWidth   = REAL [0.0,2000.]    : 'x-size of wedge',
  sHeight1  = REAL [0.0,2000.]    : 'y-size of wedge at entrance',
  sHeight2  = REAL [0.0,2000.]    : 'y-size of wedge at exit',
  sDepth = REAL [0.0,2000.]    : 'Length of wedge')

 : 'wedge volume';
END ESET

DEFINE ESET
 dTrap=(
  cName       = CHA4              : 'Name of Volume',
  sWidthLow1 = REAL [0.0, 2000.]  : 'Width in X at YMIN, ZMIN ',
  sWidthHigh1 = REAL [0.0, 2000.] : 'Width in X at YMAX, ZMIN ',
  sHeight1  = REAL [0.0,2000.]    : 'Height at ZMIN',
  sWidthLow2 = REAL [0.0, 2000.]  : 'Width in X at YMIN, ZMAX ',
  sWidthHigh2 = REAL [0.0, 2000.] : 'Width in X at YMAX, ZMAX ',
  sHeight2  = REAL [0.0,2000.]    : 'Height at ZMAX',
  sDepth = REAL [0.0,2000.]       : 'Length along Z',
  aTheta = REAL [0.0, 180.0]      : 'Polar angle of line joining ZMIN,ZMAX faces',
  aPhi = REAL [-360., 360.]       : 'Azimuthal angle ',
  aTwist = REAL [-360., 360.]     : 'Twist angle at ZMIN, ZMAX',
  aTheta1 = REAL,
  aTheta2 = REAL )
 : 'General Trapezoid';
END ESET

DEFINE ESET
 dPiece=(
  pXCent    = REAL [-2000.0,2000.]    : 'x-position of volume center',
  pYCent    = REAL [-2000.0,2000.]    : 'y-position of volume center',
  pZCent    = REAL [-2000.0,2000.]    : 'z-position of volume center',
  cText     = CH32 : 'Descriptive Text',
  Many      = INTE [0,1] : 'set ONLY/MANY flag to MANY')
 : 'define piece of junk with position and rotation';
END ESET

DEFINE ESET
 dSuper=(
  cName       = CHA4            : 'Name of Volume (H...,F...,etc)',
  pXCent    = REAL [-2000.0,2000.]    : 'x-position of volume center',
  pYCent    = REAL [-2000.0,2000.]    : 'y-position of volume center',
  pZCent    = REAL [-2000.0,2000.]    : 'z-position of volume center',
  sWidth  = REAL [1.0,300.]   : 'x-size of the supervolume',
  sHeight = REAL [1.0,200.]   : 'y-size of the supervolume',
  sDepth  = REAL [0.1,100.]   : 'z-size of the supervolume')
 : 'define a super volume';
END ESET

DEFINE ESET
 dField = (
   pZTmin = REAL [-2000.0, 2000.0]:'z-pos of beginning of target field region',
   pZTmax = REAL [-2000.0, 2000.0]:'z-pos of end of target field region',
   pZMmin = REAL [-2000.0, 2000.0]:'z-pos of beginning of main field region',
   pZMmax = REAL [-2000.0, 2000.0]:'z-pos of end of main field region')
END ESET


DEFINE ESET
 dApparatus=(
  cName    = CHA4              : 'Name of Apparatus (e.g. MAGN)',
  Disable  = INTE [0,1]        : 'Flag to disable all parts of an Apparatus',
  pXCent   = REAL [-2000.0, 2000.]   : 'x-position',
  pYCent   = REAL [-2000.0, 2000.]   : 'y-position',
  pZCent   = REAL [-2000.0, 2000.]   : 'z-position',
  MakeMother = INTE [0,1] : 'Flag to create a mother volume for the Apparatus')
 : 'general piece of apparatus (e.g. MAGNet)';
END ESET

DEFINE ESET
 dSimpleRot=(
  cType    = CHA4              : 'Type of Rotation (about X or Y axis)',
  aXYRot   = REAL              : 'Rotation (in Degrees) about X or Y ',
  aZRot    = REAL              : 'Tilt about Z is allowed also' )
 :  'Simple rotation about Z (first) then about X or Y';
END ESET

DEFINE ESET
 dGeneralRot=(
  aTheta1  = REAL              : 'Theta for Rotated X axis',
  aPhi1    = REAL              : 'Phi for Rotated X axis',
  aTheta2  = REAL              : 'Theta for Rotated Y axis',
  aPhi2    = REAL              : 'Phi for Rotated Y axis',
  aTheta3  = REAL              : 'Theta for Rotated Z axis',
  aPhi3    = REAL              : 'Phi for Rotated Z axis')
 : 'General rotation as specified to GEANT';
END ESET

DEFINE RSET
   (dVCPl   [1,1] -> [1,6] dVCDet) : 'VC planes belong to a detector';
   (dWirePl [1,1] -> [1,6] dWireDet) : 'Wire planes belong to a detector';
   (dTRDPl  [1,1] -> [1,6] dTRDDet)  : 'TRD planes belong to the TRD det.';
   (dPiece  [1,1] -> [0,*] dBox     |
                  -> [0,*] dTube    |
                  -> [0,*] dCone    |
                  -> [0,*] dWedge   |
                  -> [0,*] dTrap    |
                  -> [0,*] dEllTube |
                  -> [0,*] dSphere
                  BY dShape)   : 'Pieces may have different shapes';
   (dPiece [1,1] -> [0,1] dPiece BY Mother)
                               : 'Piece may have explicit Mother';
   (dPiece [0,1] -> [1,*] dApparatus)
                               : 'Pieces may belong to an Apparatus';
   (dShowerDet [0,1] -> [1,*] dApparatus)
                    : 'detectors may also belong to Apparatyus';
   (dVCDet [0,1] -> [1,*] dApparatus);
   (dWireDet [0,1] -> [1,*] dApparatus);
   (dTRDDet [0,1] -> [1,*] dApparatus)
                    : 'pointer to an alternate coordinate system';
   (dShowerDet [0,1] -> [1,*] dgTRACK);
   (dShowerDet [0,1] -> [1,*] dgDigiTPAR 
                        BY dgDigiTPAR);
   (dShowerDet [0,1] -> [1,*] dgDigiTPAR 
                        BY dgDigiTPARRad);
   (dVCDet [0,1] -> [1,*] dgTRACK);
   (dVCDet [0,1] -> [1,*] dgDigiTPAR);
   (dWireDet [0,1] -> [1,*] dgTRACK);
   (dWireDet [0,1] -> [1,*] dgDigiTPAR);
   (dDummyDet [0,1] -> [1,*] dgTRACK);
   (dDummyDet [0,1] -> [1,*] dgDigiTPAR);
   (dDummyDet [1,1] -> [0,*] dPiece);
   (dTRDDet [0,1] -> [1,*] dgTRACK);
   (dTRDDet [0,1] -> [1,*] dgDigiTPAR);
   (dApparatus [0,1] -> [1,*] dgTRACK);
   (dApparatus [0,1] -> [1,*] dgDigiTPAR);
   (dBox [0,1] -> [1,*] dgTRACK);
   (dBox [0,1] -> [1,*] dgDigiTPAR);
   (dCone [0,1] -> [1,*] dgTRACK);
   (dCone [0,1] -> [1,*] dgDigiTPAR);
   (dTube [0,1] -> [1,*] dgTRACK);
   (dTube [0,1] -> [1,*] dgDigiTPAR);
   (dWedge [0,1] -> [1,*] dgTRACK);
   (dWedge [0,1] -> [1,*] dgDigiTPAR);
   (dTrap [0,1] -> [1,*] dgTRACK);
   (dTrap [0,1] -> [1,*] dgDigiTPAR);
   (dEllTube [0,1] -> [1,*] dgTRACK);
   (dEllTube [0,1] -> [1,*] dgDigiTPAR);
   (dSphere [0,1] -> [1,*] dgTRACK);
   (dSphere [0,1] -> [1,*] dgDigiTPAR);
   (dVCDet [0,1]   -> [0,*] dSimpleRot |
                     -> [0,*] dGeneralRot
                       BY dRotation);
   (dVCPl [0,1]   -> [0,*] dSimpleRot |
                     -> [0,*] dGeneralRot
                       BY dRotation);
   (dWireDet [0,1]   -> [0,*] dSimpleRot |
                     -> [0,*] dGeneralRot
                       BY dRotation);
   (dTRDDet [0,1]    -> [0,*] dSimpleRot |
                     -> [0,*] dGeneralRot
                       BY dRotation);
   (dShowerDet [0,1] -> [0,*] dSimpleRot |
                     -> [0,*] dGeneralRot
                       BY dRotation);
   (dPiece [0,1]     -> [0,*] dSimpleRot |
                     -> [0,*] dGeneralRot
                       BY dRotation);
   (dApparatus [0,1] -> [0,*] dSimpleRot |
                     -> [0,*] dGeneralRot
                       BY dRotation);
END RSET

DEFINE AGGREGATE
   iUpTime = (
     TimeEnd = INTE )
END AGGREGATE

DEFINE DATAFLOW
   dDetectors   = {dVCDet}, {dVCPl}, {dWireDet}, {dWirePl}, 
		  {dTRDDet}, {dTRDPl}, {dShowerDet}, {dDummyDet}
        : 'Detector definition input file';
   dPieces      = {dPiece},{dBox},{dCone},{dTube},{dWedge},{dEllTube},
                  {dSphere},{dTrap}
        : 'Pieces definition input file';
   dGeometries  = {dVersion},{dApparatus},{dSuper},{dField},
         dDetectors,dPieces,{dMaterial},{dSimpleRot},{dGeneralRot}
        : 'Geometry definition input file';
END DATAFLOW


DEFINE ESET
 dMaterial=(
  cName                  = CH16          : 'name of the material',
  cType         = CHA4 'W'|'M'|'V'       : 'Type of fractions specified',
  rDens         = REAL [0.000,30.]          : 'total density in g/cm**3',
  nComponents            = INTE [1,10]   : 'number of components',
  cCompName(1:10)        = CH16          : 'names of the components',
  rCompPct(1:10)         = REAL [0.00,*]   :
      'rel. proportions of components, not by weight')
 : 'materials - Components must be in dgMATE ';
END ESET


DEFINE RSET
 (dMaterial [1,1] -> [0,*] dgMATE |
                  -> [0,*] dgMIXT
           BY Media)   : 'a material is a mixture or an element';
 (dVCDet [1,1] -> [0,*] dMaterial
           BY FrameMaterial) : 'material of the frame';
 (dVCDet [1,1] -> [0,*] dMaterial BY GasMaterial)   : 'gas mixture';
 (dVCDet [1,1] -> [0,*] dMaterial
           BY FoilEnterMat) : 'material of the entrance foil';
 (dVCDet [1,1] -> [0,*] dMaterial
           BY FoilExitMat) : 'material of the exit foil';
 (dVCPl  [1,1] -> [0,*] dMaterial
           BY Foil1Material) : 'material of the entry foil for each plane';
 (dVCPl  [1,1] -> [0,*] dMaterial
           BY Foil2Material) : 'material of the exit foil for each plane';
 (dVCPl  [1,1] -> [0,*] dMaterial
           BY WireMaterial)  : 'sense wire material';
 (dVCPl  [1,1] -> [0,*] dMaterial
           BY WirePMaterial) : 'potential wire material';
 (dWireDet [1,1] -> [0,*] dMaterial
           BY FrameMaterial) : 'material of the frame';
 (dWireDet [1,1] -> [0,*] dMaterial BY GasMaterial)   : 'gas mixture';
 (dWireDet [1,1] -> [0,*] dMaterial
           BY FoilEnterMat) : 'material of the entrance foil';
 (dWireDet [1,1] -> [0,*] dMaterial
           BY FoilExitMat) : 'material of the exit foil';
 (dWireDet  [1,1] -> [0,*] dMaterial
           BY Foil1Material) : 'material of the entry foil for each plane';
 (dWireDet  [1,1] -> [0,*] dMaterial
           BY Foil2Material) : 'material of the exit foil for each plane';
 (dWireDet  [1,1] -> [0,*] dMaterial
           BY WireMaterial)  : 'sense wire material';
 (dWireDet  [1,1] -> [0,*] dMaterial
           BY WirePMaterial) : 'potential wire material';
 (dTRDDet [1,1] -> [0,*] dMaterial
           BY FrameMaterial) : 'material of the frame';
 (dTRDDet [1,1] -> [0,*] dMaterial
           BY GasMaterial)   : 'gasmixture of the TRD';
 (dTRDDet [1,1] -> [0,*] dMaterial 
           BY FlushMix)      : 'gas mixture for the TRD flush gaps';
 (dTRDDet [1,1] -> [0,*] dMaterial BY FoilEnterMat);
 (dTRDDet [1,1] -> [0,*] dMaterial BY FoilExitMat);
 (dTRDDet  [1,1] -> [0,*] dMaterial BY ShieldMaterial);
 (dTRDDet  [1,1] -> [0,*] dMaterial BY RadMaterial);
 (dTRDDet  [1,1] -> [0,*] dMaterial 
           BY Foil1Material) : 'material of the entry foil for each plane' ;
 (dTRDDet  [1,1] -> [0,*] dMaterial 
           BY Foil2Material) : 'material of the exit foil for each plane' ;
 (dTRDDet  [1,1] -> [0,*] dMaterial 
           BY WireMaterial) : 'sense wire material'; 
 (dShowerDet [1,1] -> [0,*] dMaterial BY FrameMaterial);
 (dShowerDet [1,1] -> [0,*] dMaterial BY ClampMaterial);
 (dShowerDet [1,1] -> [0,*] dMaterial BY DetMaterial);
 (dShowerDet [1,1] -> [0,*] dMaterial BY RadMaterial);
 (dShowerDet [1,1] -> [0,*] dMaterial BY PMMaterial);
 (dBox [1,1] -> [0,*] dMaterial);
 (dBox [1,1] -> [0,*] dMaterial BY dMaterialIn);
 (dCone [1,1] -> [0,*] dMaterial);
 (dCone [1,1] -> [0,*] dMaterial BY dMaterialIn);
 (dWedge [1,1] -> [0,*] dMaterial);
 (dTrap [1,1] -> [0,*] dMaterial);
 (dTube [1,1] -> [0,*] dMaterial);
 (dTube [1,1] -> [0,*] dMaterial BY dMaterialIn);
 (dEllTube [1,1] -> [0,*] dMaterial);
 (dEllTube [1,1] -> [0,*] dMaterial BY dMaterialIn);
 (dSphere [1,1] -> [0,*] dMaterial);
 (dSuper [1,1] -> [0,*] dMaterial) : 'Default Material for a SuperVolume';
END RSET

DEFINE RSET
   (dShowerDet [0,1] -> [0,1] dShowerDet
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dApparatus [0,1] -> [0,1] dApparatus
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dDummyDet [0,1] -> [0,1] dDummyDet
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dVCDet [0,1] -> [0,1] dVCDet
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dVCPl  [0,1] -> [0,1] dVCPl
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dWireDet [0,1] -> [0,1] dWireDet
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dWirePl  [0,1] -> [0,1] dWirePl
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dTRDDet  [0,1] -> [0,1] dTRDDet
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dTRDPl   [0,1] -> [0,1] dTRDPl
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dPiece   [0,1] -> [0,1] dPiece
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dBox     [0,1] -> [0,1] dBox
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dCone    [0,1] -> [0,1] dCone
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dTube    [0,1] -> [0,1] dTube
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dWedge   [0,1] -> [0,1] dWedge
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dTrap   [0,1] -> [0,1] dTrap
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dEllTube [0,1] -> [0,1] dEllTube
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dSphere  [0,1] -> [0,1] dSphere
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
   (dSuper   [0,1] -> [0,1] dSuper
                   BY dUpdated) = iUpTime  : 'replaced by updated row';
END RSET

DEFINE DATAFLOW
  dgALL = dGeometries, dgGeometries
        : 'Everything I need to do the Geometry conversion';
END DATAFLOW

END SUBSCHEMA
