SUBSCHEMA rcSet AUTHOR 'Wolfgang Wander'

DEFINE ESET
 rcSETKey =
 (
   iTimeStart = INTE: 'Start of validity',
   iTimeEnd   = INTE: 'End of validity',
   iLocalId   = INTE: 'Local ID field for Dad updating',
   cType    = CH32                 : 'Selection type'

 ) : 'Key for hrc Setup';
END ESET


DEFINE ESET
 rcSET     = (rEThresh      = REAL [  0.000,40.000]:
                'd=1;TRACK:Threshold for peak finding in calor    (GeV)  ',
              rMaxSlope     = REAL [  0.000,100.00]:
                'd=1;TRACK:Maximum slope for a track to find      (1)    ',
              rMaxXRoad     = REAL [  0.000,10.00]:
		'd=1;TRACK:Maximum Road with in x for u-v match   (cm)   ',
              rMaxRoad      = REAL:
		'd=1.8;TRACK:Maximum Road with for u-v search     (bins) ',
              rMaxVCRoad    = REAL:
	        'd=1.0;TRACK:Maximum Road for the VC Fitting      (cm)   ',
              rMagnMatchY(2) = REAL [  0.000,10.00]:
		'd=1;TRACK:Maximum Ydist. of track in mag.center  (cm)   ',
              rMagnMatchX(2) = REAL [  0.000,20.00]:
                'd=1;TRACK:Maximum Xdist. of track in mag.center  (cm)   ',
	      rMagnMatchYSl(2) = REAL [  0.000,0.500]:
		'd=1;TRACK:Maximum Yslope diff. in mag.center     (1)    ',
	      rXSlopeSep    = REAL [  0.000,0.100]:
		'd=1;TRACK:X-Slope diff. for selection            (1)    ',
              rClusterSigma= REAL [  0.000,100.0]: 
                'd=4.5;TRACK:width of an average cluster          (cm)   ',
              rClusterMinProb = REAL [ 0.00, 1.00]:
	        'd=0.1;TRACK:min. Probablily for Cluster Finding  (1)    ',
              rClusterTrigger = REAL [ 0.00, 40.0]: 
		'd=0.0;TRACK;Cluster Trigger Energy               (GeV)  ',
              rCaloColumnTrg      = REAL [ 0.00, 40.0 ]:
		'd=0.0;TRACK;Calorimeter Columnswise Trigger level(GeV)  ',
              rTRDCut             = REAL [ 0.00, 40.0 ]: 
		'd=0.0;TRACK;Cut for collected energy by electrons(GeV)  ',
              rVertexSig          = REAL [ 0.00, 40.0 ]: 
		'd=3.0;TRACK;Cut for combining vertices (sigma)',
              bRecoHits           = INTE [ 0, 1 ]: 
		'd=1;TRACK;Reconstruct from Hits, too',
   	      bFastOut            = INTE [ 0, 1 ]: 
		'd=0;TRACK;Output Results to stdout',
   	      bCaloCheck          = INTE [ 1, 4 ]:
                'd=3;TRACK;Cluster Algorithm',
              bSelectCaloCl       = INTE [ 0, 1]: 
		'd=0;TRACK;Select cells for energy collection',
   	      bUseMagnet          = INTE [0,1]: 
		'd=1;TRACK;Use Magnet Chambers',
   	      bUseHomog           = INTE [0,1]: 
		'd=0;TRACK;Use Homogenous Field',
   	      bAddBrems           = INTE [0,1]: 
		'd=1;TRACK;Add in Brems Cluster',
   	      bAmbig              = INTE [0,1]: 
		'd=1;TRACK;Resolve Ambigs in Pattern Setting',
              iMissingVC(2)       = INTE [0,6]:
                'd=6;Maximum Allowed missing hits in VC',
   	      iMissingTL(3)       = INTE [0,12]: 
		'd=3;TRACK;Number of hits that may be missing / Treeline',
   	      iMissingPT(3)       = INTE [0,12]: 
		'd=3;TRACK;Number of hits that may be missing / Parttr.',
   	      iMagnetMiss         = INTE [0,12]: 
		'd=3;TRACK;Number of hits that may miss in MChambers',
   	      iLevels(3)          = INTE [0,14]: 
		'd=11;TRACK;Tree-Search Levels - refer tt. manual',
   	      bShift              = INTE [0,1]: 
		'd=0;TRACK;Use shifting to solve binning problems(old)',
   	      cAligFile           = CH64: 
		'd=;TRACK;Alignment Filename',
	      cInDriver           = CH64: 
		'd=;TRACK;Driver Options for reading events',
	      cInFile             = CH64: 
		'd=;TRACK;Filename to read events from',
	      cOutDriver          = CH64: 
		'd=;TRACK;Driver Options for writing events',
	      cOutFile            = CH64: 
		'd=;TRACK;Filename to write events to',
	      bWrDigit            = INTE[0,1]: 
		'd=0;TRACK;Write Digits to Output, too',
	      iNoOutput           = INTE[0,1]: 
		'd=0;TRACK;Disable Adamo output',
	      iNtupleId           = INTE[0,65535]: 
		'd=10;TRACK;Ntuple Id for Writing Ntuples',
	      cNtupleFile         = CH64: 
		'd=;TRACK;Ntuple Filename',
	      bNtupleAll          = INTE[0,1]: 
		'd=0;TRACK;Write all all Tracks not only e',
              bDCcalib(2)         = INTE [0,1]:
	        'd=1:CALIB;Use Drift Chamber 3rd Level Calibration',
              bDCtOcorr(2)        = REAL [0.0,100.0]:
	        'd=5:CALIB;Averaged t0 was measured at xx chamber height',
              bDCcsignal(2)       = REAL [0.0,100.0]:
	        'd=5:CALIB;Signal speed in percent of speed of light',
              bDCcdrift(2)        = REAL [0.00,100.00]:
	        'd=5:CALIB;Drit speed in mm/us',
	      cLookupFile         = CH64: 
		'd=;TRACK;Name of the momentum lookup table',
	      cGeomFile           = CH64: 
		'd=;TRACK;Name of the geometry file',
	      iMaxMult            = INTE: 
		'd=0;TRACK;Maximum Multiplicity in each chamber',
	      iMinEvNr            = INTE: 
		'd=0;TRACK;Smallest Event number to process',
	      iMaxEvNr            = INTE: 
		'd=0;TRACK;Highest Event number to process',
	      iFrontStd           = INTE [0,1]:
                'd=1;TRACK;Use Standard Reconstruction in Front Region',
	      iFrontNoVC           = INTE [0,1]:
                'd=1;TRACK;Use Reconstruction without VC / Use ForceBridge',
	      iFrontFitVC          = INTE [0,1]:
                'd=1;TRACK;Fit Forcebridged Fronttracks to VC Hits',
	      cComment   = CH32: 
		'Comment on the used rcSet',
	      iVersion   = INTE: 'Version of hrc',
	      iTimeStart = INTE: 'Start of validity',
	      iTimeEnd   = INTE: 'End of validity',
	      iLocalId   = INTE: 'Local ID field for Dad updating')
   :'Setup Parameters for hrc';
END ESET


DEFINE ESET
 rcSetVar=(cName = CHA8: 'option (variable) Name',
           cComment = CH64 : 'Explanation',
           cDefault = CH32 : 'Default value',
           cType  = CHA4 'REAL'|'INTE'|'LOGI'|'CHA4' : 'Type of option',
           cRange = CH32 : 'Range',
           cUName = CHA8 : 'Upper case variable name')
          :'table of all variables in mcSet';
END ESET

DEFINE ESET
 rcSetMenu=(cName = CHA8 : 'Menu Name')
          :'table of all menus of variables in mcSet';
END ESET

DEFINE DATAFLOW
   rcSETs = {rcSET}
           : 'hrc Setup';
END DATAFLOW

END SUBSCHEMA

