SUBSCHEMA MCarlo AUTHOR 'Michael Dueren'

DEFINE ESET
 mcEvKey =( iEvent = INTE [1,*] : 'Event Number',
            iRun   = INTE [1,*] : 'Run Number',
            cType    = CH32       : 'Selection type')
            : 'Key for Monte Carlo event generation';
END ESET


DEFINE ESET
 mcEvent   = (
	cType = CHA4 'DIS'|'DISR'|'MOL'|'MOLR'|'BEAM' :'event generation type',
	iEvent = INTE [0,*]  :'event number',
	nRndm1 = INTE :'random seed 1 of this event',
	nRndm2 = INTE :'random seed 2 of this event',
	iEvGen = INTE :'number of events generated to produce this one',
	process = INTE :'process code (LEPTO:LST(24), PYTHIA:MSTI(1))',
	nucleon = INTE :'struck nucleon (1=p, 2=n)',
	qflavour = INTE :'struck quark flavour',
	remnant = INTE :'remnant code (LEPTO:LST(27))',
	Weight = REAL [0.000,*] :'MC event weight',
	X= REAL [0.000,1.] :'x-Bjorken',
	Y= REAL [0.000,1.] :'y-Bjorken',
	Nu= REAL [0.000,40.] :'nu=e-ep',
	Q2= REAL [0.000,1000.] :'inv. momentum exchange Q**2',
	W2= REAL [0.000,1000.] :'inv. final state mass W**2',
	EP= REAL [0.000,40.] :'outgoing energy',
	The= REAL [0.000,3.2] :'scatt. angle',
	Phi= REAL [0.000,6.3] :'azimutal angle',
	PolB = REAL :'beam polarization state',
	PolT = REAL :'target polarization state')
                            :'monte-carlo event information';
END ESET

DEFINE ESET
 mcStrFu   = (
	code = REAL :'KF Lund particle code, or (A-Z)/A mixing fraction',
	x = REAL :'x value',
	Q2 = REAL :'Q2 value',
	d = REAL :'d density',
	u = REAL :'u density',
	s = REAL :'s density',
	c = REAL :'c density',
	b = REAL :'b density',
	t = REAL :'t density',
	g = REAL :'g density',
	dbar = REAL :'dbar density',
	ubar = REAL :'ubar density',
	sbar = REAL :'sbar density',
	cbar = REAL :'cbar density',
	bbar = REAL :'bbar density',
	tbar = REAL :'tbar density',
	dd = REAL :'delta d density',
	du = REAL :'delta u density',
	ds = REAL :'delta s density',
	dc = REAL :'delta c density',
	db = REAL :'delta b density',
	dt = REAL :'delta t density',
	dg = REAL :'delta g density',
	ddbar = REAL :'delta dbar density',
	dubar = REAL :'delta ubar density',
	dsbar = REAL :'delta sbar density',
	dcbar = REAL :'delta cbar density',
	dbbar = REAL :'delta bbar density',
	dtbar = REAL :'delta tbar density')
			:'structure function information';
END ESET

DEFINE ESET
 mcBeam    = (
	XSl = REAL [-5.0000,5.] :'x-slope of beam',
	YSl = REAL [-5.0000,5.] :'y-slope of beam',
	XVx = Coordinate :'x-vertex',
	YVx = Coordinate :'y-vertex',
	ZVx = Coordinate :'z-vertex',
	EBe = Energy :'beam energy')
			:'beam and vertex information';
END ESET


DEFINE ESET
 mcRadCor  = (
	cType= CHA4 'inel'|'qela'|'elas' :'type of event at true vertex',
	XTrue= REAL [0.000,1.] :'true x-Bjorken (seen by proton)',
	YTrue= REAL [0.000,1.] :'true y-Bjorken (seen by proton)',
	NuTrue= REAL [0.000,40.] :'nuTrue=e-ep-eBrems',
	Q2True= REAL [0.000,1000.] :'true inv. momentum exchange Q**2',
	W2True= REAL [0.000,1000.] :'true inv. final state mass W**2',
	ThetaBrems= REAL [0.000,6.3] :'theta of rad. photon (TSAI system)',
	PhiBrems= REAL [0.000,6.3] :'phi of rad. photon (in TSAI system)',
	SigRad= REAL [0.000,1.e5] :'radiatively corrected crosssection',
	SigCor= REAL [0.100,100.] :'radiative correction factor',
	SigCorErr= REAL [0.000,100.] :'error on rad. correction factor',
	TailIne= REAL [0.000,1.e5] :'inelastic radiative tail',
	TailEla= REAL [0.000,1.e5] :'quasi-elastic tail',
	TailCoh= REAL [0.000,1.e5] :'coherent tail',
	Vacuum= REAL [0.000,1.] :'vacuum pol. factor',
	Vertex= REAL [0.000,1.] :'vertex correction',
	Small= REAL [0.000,1.] :'small rad. corr.',
	RedFac= REAL [0.000,10.] :'rad. reduction factor',
	EBrems= Energy   :'energy of radiative photon')
			:'radiative correction calculations';
END ESET

DEFINE ESET
 mcTrack   = (
	cType  = CHA4 :'generation type',
	iCharge= INTE [-1,1]:'charge',
	iGType = INTE [-1000,1000]:'GEANT part. type',
	iLType = INTE [-10000,10000]:'LUND part. type',
	The = REAL :'polar angle',
	Phi = REAL :'azimuthal angle',
	Px = Momentum :'x-momentum',
	Py = Momentum :'y-momentum',
	Pz = Momentum :'z-momentum',
	P  = Momentum :'momentum',
	E  = Energy   :'energy',
	M  = Energy   :'mass',
	Pmagnet = Momentum :'|momentum| just after magnet',
	GeantID = INTE :'GEANT track number')
			:'monte-carlo track information';
END ESET

DEFINE ESET
 mcVert   = (
	X = Coordinate :'x-vertex',
	Y = Coordinate :'y-vertex',
	Z = Coordinate :'z-vertex',
	GeantID = INTE :'GEANT vertex number')
			:'track vertices';
END ESET

DEFINE ESET
 mcHit     = (
	Module=INTE [0,1000]  : 'module number',
	iGType = INTE [-1000,1000]   :'GEANT part. type (may be second.)',
	iStak  = INTE [-10000,10000] :'GEANT stack number (second.)',
	TOF=REAL              : 'Time of Fl. (resp.HERA clock) at entr.',
	X=Coordinate          : 'x-Coordinate',
	Y=Coordinate          : 'y-Coordinate',
	Z=Coordinate          : 'z-Coordinate',
	XEnter=Coordinate     : 'x-Coordinate at volume entrance',
	YEnter=Coordinate     : 'y-Coordinate at volume entrance',
	ZEnter=Coordinate     : 'z-Coordinate at volume entrance',
	E=Energy              : 'Energy',
	rDE=Energy            : 'Energy loss')
			:'monte-carlo hit information';
END ESET

DEFINE ESET
 mcTrigger =  (
	TrmG0116  =INTE   :'trigger mask [gen] (trigger types  1-16)',
	TrmG1732  =INTE   :'trigger mask [gen] (trigger types 17-32)',
	TrmG3348  =INTE   :'trigger mask [gen] (trigger types 33-48)',
	TrmG4964  =INTE   :'trigger mask [gen] (trigger types 49-64)')
			:'event trigger information';
END ESET


DEFINE ESET
 mcName=(
	cKey  = CHA4: 'Key of filename',
	iUnit = INTE [0,99]: 'unit number',
	cDriver = CH16: 'DAD/ADAMO driver',
	cName = CH64: 'filename',
	cHelp = CH64: 'help string')
			:'table of all file names';
END ESET


DEFINE ESET
 mcUser=(
	Name = CH16	: 'name of user variable',
	Val = REAL	: 'real value of variable')
			: 'table free for use by any user';
END ESET

DEFINE ATTRIBUTE
        Momentum   = REAL [-100.000,100.]   : 'momentum in GeV';
        Energy     = REAL [0.000,100.]   : 'energy in GeV';
        Coordinate = REAL [-1000000.000,1000000.000]   : 'position in cm';
END ATTRIBUTE

DEFINE ESET
     mcDig2Hit :                      'Generalized relationship between
                                       hits and new digits';
END ESET

DEFINE RSET 
     ( mcDig2Hit[1,1] -> [1,*] mcHit): 'connect to hit table';
     ( mcDig2Hit [1,1] ->[0,*] dataProp |
                      -> [0,*] dataPuls |
                      -> [0,*] dataHodo |
                      -> [0,*] dataCalo
                 BY detName): 'Gen rel to digit table';
END RSET


DEFINE RSET
 (mcEvent [0,1] -> [0,1] mcTrack
		BY qTrack)	:'LEPTO struck q track via LST(26)';
 (mcTrack [1,1] -> [1,*] mcVert
		BY startVert)    :'Monte carlo tracks start somewhere';
 (mcTrack [1,1] -> [1,*] mcVert
		BY stopVert)    :'Monte carlo tracks stop somewhere';
 (mcTrack [1,1] -> [1,*] mcVert
		BY magVert)    :'Back track position just after magnet';
 (mcTrack [0,1] -> [0,*] mcTrack
		BY Parent)    :'Primary tracks may have parent tracks';
 (mcHit [1,1] -> [0,*] mcTrack)      :'Monte carlo tracks have hits';
 (mcHit [1,1] -> [0,*] dgDETS)       :'Monte carlo hits belong to detectors';
END RSET

DEFINE ESET
 mcSetPar=(
	Name        = CH16   :'Set parameter name',
	Value       = CH16   :'Set parameter value')
			:'Set parameter storage';
END ESET

DEFINE ESET
 mcDigiPar=(
	Name        = CH32   :'digitization parameter name',
	Value       = REAL   :'digitization parameter value')
			:'digitization parameter';
END ESET

DEFINE ESET
 mcDetEff=(
	PosiDetEff      = REAL   :'detector efficiency for DIS positrons',
	HadrDetEff      = REAL   :'detector efficiency for hadrons')
			:'detector efficiencies';
END ESET

DEFINE ESET
 mcChanEff=(
	FirstChan   = INTE   :'first channel of validity for efficiency',
	LastChan    = INTE   :'last channel of validity for efficiency',
	ChanEff(4)  = REAL   :'channel efficiency parametrization (p1+p2*n+...)')
			:'channel efficiencies';
END ESET

DEFINE RSET
 (mcDetEff  [1,1] -> [0,*] dgDETS)       :'Detector efficiencies belong to detectors';
 (mcChanEff [1,1] -> [0,*] dgDETS)       :'Channel efficiencies belong to detectors';
END RSET


DEFINE DATAFLOW
   mcEvData= {mcEvent},{mcBeam},{mcStrFu},{mcTrack},{mcVert},{mcHit},{mcRadCor},
             {mcUser},{mcTrigger},{mcDig2Hit},dataDfl
           : 'Monte Carlo event information';
   mcEvents= {mcSetPar},{mcDigiPar},{mcDetEff},{mcChanEff},mcEvData
           : 'Monte Carlo event information with parameter settings';
END DATAFLOW

DEFINE ESET
 ugenKey=(
	iEvent = INTE [1,*] : 'Event Number',
	iRun   = INTE [1,*] : 'Run Number',
	cType  = CH32       : 'Selection type')
			:'Key for user generator event generation';

 ugenEvent=(
	cType = CHA4 'DIS'|'DISR'|'MOL'|'MOLR'|'BEAM' :'event generatioon type',
	iEvent = INTE [0,*]  :'event number',
	iRepKine = INTE : 'repeated kinematics',
	nRndm1 = INTE :'d= 0;HMC random seed 1. =0 => HMC choose the seed',
	nRndm2 = INTE :'d= 0;HMC random seed 2. =0 => HMC choose the seed', 
	Weight = REAL [0.000,*] :'MC event weight',
	X= REAL [0.000,1.] :'x-Bjorken',
	Y= REAL [0.000,1.] :'y-Bjorken',
	Nu= REAL [0.000,40.] :'nu=e-ep',
	Q2= REAL [0.000,1000.] :'inv. momentum exchange Q**2',
	W2= REAL [0.000,1000.] :'inv. final state mass W**2',
	EP= REAL [0.000,40.] :'outgoing energy',
	The= REAL [0.000,3.2] :'scatt. angle',
	Phi= REAL [0.000,6.3] :'azimutal angle')
			:'user generator event information';

 ugenBeam=( 
	XVx = Coordinate :'x-vertex',
	YVx = Coordinate :'y-vertex',
	ZVx = Coordinate :'z-vertex')
			:'vertex information';

 ugenTrack=(
	cType  = CHA4 'init'|'beam'|'scat'|'virt'|'lund'|'peps'|'radi'|'dcay',
	iGType = INTE [-1000,1000]:'GEANT part. type',
	iLType = INTE [-10000,10000]:'LUND part. type',
	Px = Momentum :'x-momentum',
	Py = Momentum :'y-momentum',
	Pz = Momentum :'z-momentum')
			:'user generator track information';
END ESET

DEFINE RSET
 (ugenTrack [0,1] -> [0,*] ugenTrack
		BY Parent)    :'Primary tracks may have parent tracks';
END RSET



DEFINE DATAFLOW
   ugenEvents= {ugenEvent},{ugenTrack},{ugenBeam}
           : 'User generator event information';
END DATAFLOW



END SUBSCHEMA
