
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Be sure we get our local versions of cfortran.h and adamo.h,
   before they are grabbed from elsewhere by other include files */
#ifndef NOCFORT
#include <cfortran.h>
#endif
#include <adamo.h>

#include <hanna.h>
#include <hbook.h>

/* memory for initap: ZEBRA and ADAMO */
#define MEMSZ 2000000
#include <initap.h>

/* memory for PAW and HBOOK */
#define PAWSZ 500000
#define PAWC COMMON_BLOCK(PAWC,pawc)
typedef struct { int hmemor[PAWSZ]; } PAW_DEF;
COMMON_BLOCK_DEF(PAW_DEF,PAWC);
PAW_DEF PAWC;

/* we will call the F77 version of CREOBJ, since only the F77 code will
   need these structures (hanna is DDL free) */
#define	CREOBJ() CCALLSFSUB0(CREOBJ,creobj)

PROTOCCALLSFFUN0(INT,USER_ARGS,user_args)
#define USER_ARGS() CCALLSFFUN0(USER_ARGS,user_args) 
#define MAXARG 200
#define MAXSTRINGLEN 132
int swIpointer[MAXARG];
char *swCpointer[MAXARG];
char *swCname[MAXARG];
int topindex = -1;

/* ========================================================================
   Provide wrappers for familiar HEPM fortran user functions
   ======================================================================== */

int main (int argc, char*argv[] ) {
	if (USER_ARGS()) { 
	  fprintf (stderr, "\n  ERROR in routine user_args\n\n"); exit(1); 
	}
	return ha_main (argc,argv) ;
}

/* -------------------------------------------------------------------------
   HEP-like user routines = declaring the F77 routines to HANNA
   ------------------------------------------------------------------------ */

PROTOCCALLSFFUN0(INT,USER_INIT,user_init)
#define USER_INIT() CCALLSFFUN0(USER_INIT,user_init) 
int user_init ( void ) { 
	printf("Initializing HBOOK ... ");
	HLIMIT(-PAWSZ); 
	printf("done.\n");
	return USER_INIT(); 
}

PROTOCCALLSFFUN1(INT,USER_END,user_end,PINT) 
#define USER_END(i) CCALLSFFUN1(USER_END,user_end,PINT,i) 
int user_end ( int retcode ) { 
	return USER_END(retcode); 
}

PROTOCCALLSFFUN1(INT,USER_RUNINIT,user_runinit,PINT)
#define USER_RUNINIT(i) CCALLSFFUN1(USER_RUNINIT,user_runinit,PINT,i) 
int user_runinit ( int runnum ) { 
	return USER_RUNINIT(runnum); 
}

PROTOCCALLSFFUN1(INT,USER_RUNEND,user_runend,PINT)
#define USER_RUNEND(i) CCALLSFFUN1(USER_RUNEND,user_runend,PINT,i) 
int user_runend ( int retcode ) { 
	return USER_RUNEND (retcode);
}

PROTOCCALLSFFUN7(INT,USER_EVENT,user_event,PINT,PINT,PINT,PINT,PINT,PINT,PINT)
#define USER_EVENT(i1,i2,i3,i4,i5,i6,i7) \
	CCALLSFFUN7(USER_EVENT,user_event,PINT,PINT,PINT,PINT,PINT,PINT,PINT, \
	i1,i2,i3,i4,i5,i6,i7)
int user_event ( int runnum, int eventnum, int eventtime, int eventtimemu,
		int index, int cur1, int cur2 ) {
	return USER_EVENT (runnum,eventnum,eventtime,eventtimemu,
		index,cur1,cur2); 
}

PROTOCCALLSFFUN7(INT,USER_SLOW,user_slow,PSTRING,PINT,PINT,PINT,PINT,PINT,PINT)
#define USER_SLOW(c,i1,i2,i3,i4,i5,i6) \
	CCALLSFFUN7(USER_SLOW,user_slow,PSTRING,PINT,PINT,PINT,PINT,PINT,PINT, \
	c,i1,i2,i3,i4,i5,i6)
int user_slow( char *name, int starttime, int starttimemu, int endtime, 
			int endtimemu, int flag_first, int status ) {
	return USER_SLOW ( name, starttime, starttimemu, endtime,
		endtimemu, flag_first, status );
}

PROTOCCALLSFFUN5(INT,USER_BURSTINIT,user_burstinit,PINT,PINT,PINT,PINT,PINT)
#define USER_BURSTINIT(i1,i2,i3,i4,i5) \
	CCALLSFFUN5(USER_BURSTINIT,user_burstinit,PINT,PINT,PINT,PINT,PINT, \
	i1,i2,i3,i4,i5)
int user_burstinit( int runnum, int burstnum, int bursttime, 
				int bursttimemu, int burstgood ) {
	return USER_BURSTINIT ( runnum, burstnum, bursttime, 
		bursttimemu, burstgood );
}

PROTOCCALLSFFUN1(INT,USER_BURSTEND,user_burstend,PINT) 
#define USER_BURSTEND(i) CCALLSFFUN1(USER_BURSTEND,user_burstend,PINT,i) 
int user_burstend ( int retcode ) { 
	return USER_BURSTEND( retcode); 
}

/* =========================================================================
   Supply new routines for F77 access to hanna's command line arg routines
   ======================================================================== */

/* -------------------------------------------------------------------------
   Defining new command line arguments
   (NOTE: addarg should be called from user-written routine USER_ARGS)
   ------------------------------------------------------------------------ */

void addarg (char *swname, char *valname, char *swhelp, char *def) {
	int index;
	index = topindex + 1;
	if (index < 0) {
		printf ("ERROR: Negative index value ... ???\n");
		return;
	} else if (index >= MAXARG) {
		printf("ERROR: Only MAXARG = %d arguments permitted.\n",MAXARG);
		return;
	}
	++topindex;
	swCname[index] = malloc( MAXSTRINGLEN );
	sprintf ( swCname[index], "%s", swname );

  /* If valname is NULL = \0, this is a boolean switch */

	if (*valname == '\0')  {
	  ha_addarg ( strdup(swname), &swIpointer[index], 
		NULL, strdup(swhelp) ); 
	} else {
	  ha_addarg ( strdup(swname), &swCpointer[index], 
		strdup(valname), strdup(swhelp) ); 
	  swCpointer[index] = malloc( MAXSTRINGLEN );
	  sprintf ( swCpointer[index], "%s", def );
	}
}
FCALLSCSUB4(addarg,ADDARG,addarg,STRING,STRING,STRING,STRING)

/* -------------------------------------------------------------------------
   Utility routine to return index value given a switch name
   ------------------------------------------------------------------------ */

int getarg_index (char *swname) {
	int i, index;
	index = -1;
	for (i=0; i <= topindex; i++) {
	  if (strcmp(swCname[i],swname) == 0) { index = i; break; } 
	}
	if (index < 0 || index > topindex) {
		printf ("ERROR: UNDEFINED switch %s.\n",swname);
		return -1; 
	}
	return index;
}

/* -------------------------------------------------------------------------
   Retrieving argument values from Fortran
   NOTE: argument retrieval should be done in USER_INIT
   ------------------------------------------------------------------------ */

int getarg_bool (char *swname) {
	int index;
	index = getarg_index(swname);
	if (index < 0) { return 1; }
	return ( swIpointer[index] ); 
}
FCALLSCFUN1(INT,getarg_bool,GETARG_BOOL,getarg_bool,STRING)

int getarg_int (char *swname) {
	int index;
	index = getarg_index(swname);
	if (index < 0) { return 1; }
	if (swCpointer[index] == '\0') { return 1; }
	return atoi( swCpointer[index] ); 
}
FCALLSCFUN1(INT,getarg_int,GETARG_INT,getarg_int,STRING)

float getarg_real (char *swname) {
	int index;
	index = getarg_index(swname);
	if (index < 0) { return 1; }
	if (swCpointer[index] == '\0') { return 1; }
	return (float) atof( swCpointer[index] ); 
}
FCALLSCFUN1(FLOAT,getarg_real,GETARG_REAL,getarg_real,STRING)

/* THE FUNCTION ... works, given char*xx declaration in F77 */ 
char *getarg_char (char *swname) {
	int index;
	char *null = '\0';
	index = getarg_index(swname);
	if (index < 0) { return null; }
	return swCpointer[index];
}
FCALLSCFUN1(STRING,getarg_char,GETARG_CHAR,getarg_char,STRING)

/* ========================================================================
   Here comes INITAP. The hanna libraray contains a sparse version of this
   which does not call CREOBJ 
   ======================================================================== */

/* CCALLSFSUB0(INITAP,initap) */

void INITAP() {

  static int io[] = {3,-2,-1,-1};

/* Initialize ZEBRA */
  printf("Initializing ZEBRA ... ");
  MZEBRA(io);
  printf("done.\n");

/* Initialize ADAMO */
  OPETAP(MEMSZ);

/* Create user's ADAMO entities */
#ifdef USE_CREOBJ
  printf ("Running CREOBJ (F77 version) ... ");
  CREOBJ();
  printf("done.\n");
#endif
#ifndef USE_CREOBJ
  printf ("NOTE: no CREOBJ in this code ...\n");
#endif

}


/* ========================================================================
   The exceedingly useful hermesfile routine
   ======================================================================== */

static int hermes_check_file(
  char *output, char *input, char *path, char *path2, int mode,
  int recurse_flag);	/* defined below */
int hermesfile_mode(char *output, char *input, char *mode);

static struct namelist {
  char *name;			/* dir or environment variable to chk*/
  char type;			/* type D->dir, E->envi, R->envi/lib
				 * type d->dir without return if not found */
  
} namelist[] = {
  {".", 'd'},
  {"HERMES_LIB", 'E'},
  {"HERMES_ROOT", 'R'}, 
  {".:./lib", 'D'}
};

int hermesfile (char *output, char *input)
{
	return hermesfile_mode(output, input, "r");	/* read access */
}

int
hermesfile_mode(char *output, char *input, char *mode)
{
  int i, imode;
  int nentries = sizeof(namelist) / sizeof(struct namelist);
  char *ptr, *path2;
  
  if (output != NULL) *output = '\0';
  for (i = 0; i < nentries; i++)
    {
      if (namelist[i].type != 'D' &&
	  namelist[i].type != 'd' )	/* an environment variable */
	{
	  if ((ptr = getenv(namelist[i].name)) == NULL) continue;
	}
      else
	{
	  ptr = namelist[i].name;		/* this directory */
	}
      path2 = (namelist[i].type == 'R') ? "lib" : NULL;
      if (strlen(ptr) == 0) continue;	/* Ignore blank strings */
      imode = 0;
      if (strchr(mode, 'r') != NULL) 
	{
		 imode |= R_OK;
	}
      if (strchr(mode, 'w') != NULL) imode |= W_OK;
      if (strchr(mode, 'x') != NULL) imode |= X_OK;
      if (strchr(mode, 'f') != NULL) imode |= F_OK;
      if( namelist[i].type != 'D' ) {
	if( hermes_check_file (output, input, ptr, path2, imode, 1) )
	  return 1;
      } else
	return (hermes_check_file (output, input, ptr, path2, imode, 1));
    }
  return (0);
}

static int 
hermes_check_file (
	char *output, 
	char *input, 
	char *path, 
	char *path2,
	int mode,
	int recurse_flag)
{
	char buffer[1024];
	char mypath[1024];
	char *ptr, *ptr2;
	int length;

	if (path == NULL)			/* Empty path */
	    {
	    buffer[0] = '\0';			/* by default nothing */
	    }
	else
	    {
	    if (strlen(path) < sizeof(buffer))
		{
		strcpy (buffer, path);		/* make a private copy */
		}
	    else
		{
		fprintf (stderr, 
			"buffer string too short in hermes_check_file %d \n",
			strlen(path));
		return (0);
		}
	    }
			/* First look for a file with a given access mode */
	ptr2 = buffer;
	while ((ptr = strtok(ptr2, ":")) != NULL)
	    {
	    strcpy (mypath, ptr);
	    if (path2 != NULL)
		{
		if ((length = strlen(mypath)) > 0)
		    {
		    if (mypath[length-1] != '/') 
			{
			mypath[length] = '/';
			mypath[length+1] = '\0';
			}
		    }
		strcat (mypath, path2);
		}
	    if (input != NULL) 
		{
		if ((length = strlen(mypath)) > 0)
		    {
		    if (mypath[length-1] != '/') 
			{
			mypath[length] = '/';
			mypath[length+1] = '\0';
			}
		    }
		strcat (mypath, input);
		}
	    if (!access(mypath, mode)) 
		{
	        if (output != NULL) strcpy (output, mypath);
	    	return (1);
		}
	    ptr2 = NULL;
	    }
	if (recurse_flag)	/* Okay, now look for a writable directory */
	    {
	    if (hermes_check_file(output, NULL, path, path2, W_OK, 0))
		{
		if (output != NULL) 
		    {
		    strcat (output, "/");
		    if (input != NULL) strcat (output, input);
		    }
	        return (0);
		}
	    return (0);
	    }
  return (0);
}

#ifndef NOCFORT
#ifdef linux
  FCALLSCFUN2(INT, hermesfile, HERMESFILE, hermesfile, PSTRING, STRING)
  FCALLSCFUN3(INT, hermesfile_mode, HERMESFILE_MODE_, hermesfile_mode_, 
		PSTRING, STRING, STRING)
#else
  FCALLSCFUN2(INT, hermesfile, HERMESFILE, hermesfile, PSTRING, STRING)
  FCALLSCFUN3(INT, hermesfile_mode, HERMESFILE_MODE, hermesfile_mode, 
		PSTRING, STRING, STRING)
#endif
#endif


